/**
     Album Cover Grabber - Grabs album covers automatically off the internet
     Copyright (C) 2002  Kevin M Schmidt

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.bluedragontavern.albumgrabber;

import java.util.*;


/**
 * Manages the search threads
 */
public class SearchThreadMgr
	{
	private static SearchThreadMgr instance = null;
	private List items = new ArrayList();
	private int runningThreads = 0;

	/**
     * Get singleton instance
     * @return DOCUMENT ME!
     */
	public static synchronized SearchThreadMgr getInstance()
		{
		if (instance == null)
			instance = new SearchThreadMgr();

		return instance;
		}

	/**
     * Private Singleton Constructor
     */
	private SearchThreadMgr()
		{
		ProcessSearchThreads pst = new ProcessSearchThreads();
		pst.start();
		}

	/**
     * Add chooser to the queue
     * @param album DOCUMENT ME!
     */
	public void addItemToGrab(ItemToGrab item)
		{
		ExitProgram.setSearchThreadMgrFinished(false);
		items.add(item);
		}

	private class ProcessSearchThreads
		extends Thread
		{
		//If this value is set too high, AllMusic will detect that a bot is running.
		//Your IP address will get banned on their server.  It is safest to keep it at 1.
		private int maxNumThreads = 1;

		public void run()
			{
			try
				{
				while (ExitProgram.isFinished() == false)
					{
					if (runningThreads < maxNumThreads && items.size() > 0)
						{
						SearchThread st = new SearchThread((ItemToGrab)items.remove(0));
						st.start();
						incrementRunningThreadCount();
						}
					else
						{
						Thread.sleep(250);

						//If there are no more items and no running threads, then finished
						if (items.size() == 0 && runningThreads == 0)
							ExitProgram.setSearchThreadMgrFinished(true);
						}
					}
				}
			catch (Exception ex)
				{
				System.out.println("Exception: " + ex);
				}
			}
		}

	/**
     * Each time a search thread is started, this method is called
     */
	private void incrementRunningThreadCount()
		{
		++runningThreads;
		}

	/**
     * When a thread is finished executing, it will call this method
     */
	public void decrementRunningThreadCount()
		{
		--runningThreads;
		}
	}