/**
	  Album Cover Grabber - Grabs album covers automatically off the internet
	  Copyright (C) 2002  Kevin M Schmidt

	  This program is free software; you can redistribute it and/or modify
	  it under the terms of the GNU General Public License as published by
	  the Free Software Foundation; either version 2 of the License, or
	  (at your option) any later version.

	  This program is distributed in the hope that it will be useful,
	  but WITHOUT ANY WARRANTY; without even the implied warranty of
	  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	  GNU General Public License for more details.

	  You should have received a copy of the GNU General Public License
	  along with this program; if not, write to the Free Software
	  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.bluedragontavern.albumgrabber.allmusic.pages;

import com.bluedragontavern.albumgrabber.*;
import com.bluedragontavern.albumgrabber.util.*;

import java.net.*;

import java.util.*;

import org.apache.regexp.*;


public class ArtistPage
	{
	private String html = null;

	/**
	  * Constructor
	  */
	public ArtistPage(String html)
				  throws Exception
		{
		this.html = html;
		}

	public Artist getArtist(Artist artist)
						  throws Exception
		{
		RE findImageRE = new RE("<IMG width=.*? align=left src=(.*?)>");

		//If we find a direct match
		if (findImageRE.match(html))
			{
			artist.setImageUrl(findImageRE.getParen(1));

			if (Constants.DEBUG)
				System.out.println("ArtistPage:imageUrl = " +
										 artist.getImageUrl());

			//Set the found Artist name
			if (artist.getFoundArtistName() == null)
				{
				RE artistNameRE = new RE("<font size=\\+2><B>(.*?)</B></font>");
				artistNameRE.match(html);
				artist.setFoundArtistName(artistNameRE.getParen(1));

				if (Constants.DEBUG)
					System.out.println("ArtistPage:artistName = " +
											 artist.getFoundArtistName());
				}

			//Mark the album as being found
			artist.found();
			}

		return artist;
		}

	/**
	  * Find the best matching album
	  * @param album DOCUMENT ME!
	  * @return DOCUMENT ME!
	  * @throws Exception DOCUMENT ME!
	  */
	public Album getAlbum(Album album)
						throws Exception
		{
		Vector albumNames = new Vector();
		Vector albumUrls = new Vector();

                //<tr class="co1"<TD WIDTH=83 align=right>
                //<img src="/i/np.gif"><img width=59 height=11 src="/i/rt6.gif"></TD>
                //<TD WIDTH=47>1973 <IMG src="/i/av1.gif"></TD><TD WIDTH=315>
                //<a class=a href="javascript:z('A7em1z84ajyv4')">Aerosmith</a></TD>
                //<td width=35 align="center">
                //<a href="http://service.bfast.com/bfast/click?bfmid=2181&sourceid=40140226&bfpid=074645736020&bfmtype=music" target="bn">
                //<img src="/i/bn_buy.gif" border=0 alt="" align="absmiddle"></a></td><TD WIDTH=137>
                //<A HREF="http://www.columbiarecords.com">Columbia</A></TD></TR>

		RE hits = new RE("<tr class=\"co1\"><TD WIDTH=83 align=right>.*?javascript:z\\('(.*?)'\\).*?>(.*?)</a>.*?</TR>");
		String albumName;
		String albumUrl;
		int index = 0;

		while (hits.match(html, index))
			{
			albumNames.add(hits.getParen(2));
			albumUrls.add("/cg/amg.dll?p=amg&uid=SEARCH&sql=" + hits.getParen(1));
			index = hits.getParenEnd(2);

			if (Constants.DEBUG)
				{
				System.out.println("ArtistPage:albumName = " +
										 albumNames.lastElement());
				System.out.println("ArtistPage:albumUrl = " +
										 albumUrls.lastElement());
				}
			}

		//If no hits found, just return
		if (albumNames.size() == 0)
			return album;

		//Now we have to decide which is the CORRECT album!
		Vector indexScores = CompareStrings.findBestMatchingOrder(albumNames,
																					 album.getSearchAlbumName());
		Iterator iter = indexScores.iterator();

		while (iter.hasNext())
			{
			int bestMatch = ((IndexScore)iter.next()).getIndex();
			Album bestMatchAlbum = new Album(album.getAlbumDir());
			bestMatchAlbum.setFoundAlbumName((String)albumNames.elementAt(
																bestMatch));
			bestMatchAlbum.setAlbumUrl((String)albumUrls.elementAt(bestMatch));

			//Get the URL to the album page
			URL url = new URL("http://www.allmusic.com" +
									bestMatchAlbum.getAlbumUrl());
			html = NetUtil.doGet(url, null);

			AlbumPage albumPage = new AlbumPage(html);
			bestMatchAlbum = albumPage.getAlbum(bestMatchAlbum);

			if (bestMatchAlbum.isFound())
				return bestMatchAlbum;
			}

		return album;
		}
	}