/**
		Album Cover Grabber - Grabs album covers automatically off the internet
		Copyright (C) 2002  Kevin M Schmidt

		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.bluedragontavern.albumgrabber.allmusic.pages;

import com.bluedragontavern.albumgrabber.*;
import com.bluedragontavern.albumgrabber.util.*;

import java.net.*;

import java.util.*;

import org.apache.regexp.*;


public class MultipleAlbumsPage
	{
	private String html = null;

	/**
		* Constructor
		*/
	public MultipleAlbumsPage(String html)
							 throws Exception
		{
		this.html = html;
		}

	/**
		* Process multiple albums listing page
		* @param album DOCUMENT ME!
		* @param html DOCUMENT ME!
		* @return DOCUMENT ME!
		* @throws Exception DOCUMENT ME!
		*/
	public Album getAlbum(Album album)
						throws Exception
		{
		//Multiple album pages will have at the top: "albums with titles like"
		//If the page is missing this phrase, dont bother processing.
		RE check = new RE("albums with titles like");
	   if (check.match(html) == false)
		  return album;

		Vector albumNames = new Vector();
		Vector albumUrls = new Vector();
		Vector artistNames = new Vector();

                //<tr bgcolor="#DDD4B2"><td width=2></td>
                //<td width=45 align=right>
                //<img src="/i/red_dot.jpg" valign=center width="42" height=5 border=0>&nbsp;</td>
                //<td width=465><a class=a href="javascript:z('Aom2zefukhgf5')">Draw the Line</a> [1977] - Aerosmith</TD>
                //<TD WIDTH=100>Rock&nbsp;</TD>

		//Get a list of all the albums
		RE hits = new RE("javascript:z\\('(.*?)'\\)\">(.*?)</a>.*? - (.*?)</TD>");

		//Dont match against the artist name if it contains "various"
		RE findVariousRE = new RE("various", RE.MATCH_CASEINDEPENDENT);
		boolean skipArtistName = findVariousRE.match(album.getSearchArtistName());
		int index = 0;

		while (hits.match(html, index))
			{
			artistNames.add(hits.getParen(3));
			albumNames.add(hits.getParen(2));
			albumUrls.add("/cg/amg.dll?p=amg&uid=SEARCH&sql=" + hits.getParen(1));
			index = hits.getParenEnd(3);

			if (Constants.DEBUG)
				{
				System.out.println("MultipleAlbumsPage:artistName = " +
										 artistNames.lastElement());
				System.out.println("MultipleAlbumsPage:albumName = " +
										 albumNames.lastElement());
				System.out.println("MultipleAlbumsPage:albumUrl = " +
										 albumUrls.lastElement());
				}
			}

		//If no hits found, just return
		if (albumNames.size() == 0)
			return album;

		//Now we have to decide which is the CORRECT album!
		Vector indexScores;

		//Match against either the artist name or album name
		if (skipArtistName)
			indexScores = CompareStrings.findBestMatchingOrder(albumNames,
																				album.getSearchAlbumName());
		else
			indexScores = CompareStrings.findBestMatchingOrder(artistNames,
																				album.getSearchArtistName());

		Iterator iter = indexScores.iterator();

		while (iter.hasNext())
			{
			int bestMatch = ((IndexScore)iter.next()).getIndex();
			Album bestMatchAlbum = new Album(album.getAlbumDir());
			bestMatchAlbum.setFoundArtistName((String)artistNames.elementAt(
																 bestMatch));
			bestMatchAlbum.setFoundAlbumName((String)albumNames.elementAt(
																bestMatch));
			bestMatchAlbum.setAlbumUrl((String)albumUrls.elementAt(bestMatch));

			//Get the URL to the album page
			URL url = new URL("http://www.allmusic.com" +
									bestMatchAlbum.getAlbumUrl());
			html = NetUtil.doGet(url, null);

			AlbumPage albumPage = new AlbumPage(html);
			bestMatchAlbum = albumPage.getAlbum(bestMatchAlbum);

			if (bestMatchAlbum.isFound())
				return bestMatchAlbum;
			}

		return album;
		}
	}